<?php
/*
Plugin Name: Last.fm Tabs
Plugin URI: http://felix.moches.de/en/wordpress-en/last-fm-tabs-1-0
Description: Last.fm track, album art, userinfo, shout and friends display
Version: 1.1.2
Author: Felix Moche
Author URI: http://felix.moches.de
*/

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

// Hook for adding admin menus
add_action('admin_menu', 'lastfm_tabs_adminpages_add');

function lastfm_tabs_adminpages_add() {
    add_options_page('Last.fm Tabs', 'Last.fm Tabs', 'manage_options', 'lastfm_tabs_options', 'lastfm_tabs_optionspage');
}

//uninstall
register_deactivation_hook(__FILE__,'lastfm_tabs_deactivate');

function lastfm_tabs_deactivate(){
	delete_transient('lastfm_tabs_cache');
	delete_option('lastfm_tabs_options');
}

function lastfm_tabs_optionspage() {

	$optionsarray = get_option('lastfm_tabs_options');
	if (array_key_exists('lastfm-submit', $_POST)) {
		$optionsarray['username'] = strip_tags(stripslashes($_POST['username']));
		$optionsarray['avatar_size'] = intval(@$_POST['avatar_size']);
		$optionsarray['cover_size'] = intval(@$_POST['cover_size']);
		$optionsarray['widgettitle'] = strip_tags(stripslashes($_POST['widgettitle']));
		$optionsarray['nocoverurl'] = strip_tags(stripslashes($_POST['nocoverurl']));
		$optionsarray['trackcount'] = intval($_POST['trackcount']);
		$optionsarray['friendscount'] = intval($_POST['friendscount']);
		$optionsarray['lovedcount'] = intval($_POST['lovedcount']);
		$optionsarray['shoutcount'] = intval($_POST['shoutcount']);
		$optionsarray['loved_size'] = intval($_POST['loved_size']);
		$optionsarray['expiration'] = intval($_POST['expiration']);
		if (isset($_POST['debugmode']) && intval($_POST['debugmode']) ) $optionsarray['debugmode'] = 1; else $optionsarray['debugmode'] = 0;
		if (isset($_POST['enable_shouts']) && intval($_POST['enable_shouts']) ) $optionsarray['enable_shouts'] = 1; else $optionsarray['enable_shouts'] = 0;
		if (isset($_POST['enable_coverart']) && intval($_POST['enable_coverart']) ) $optionsarray['enable_coverart'] = 1; else $optionsarray['enable_coverart'] = 0;
		if (isset($_POST['enable_friends']) && intval($_POST['enable_friends']) ) $optionsarray['enable_friends'] = 1; else $optionsarray['enable_friends'] = 0;
		if (isset($_POST['enable_lovedtracks']) && intval($_POST['enable_lovedtracks']) ) $optionsarray['enable_lovedtracks'] = 1; else $optionsarray['enable_lovedtracks'] = 0;
		if (isset($_POST['enable_coverart']) && intval($_POST['enable_coverart']) ) $optionsarray['enable_coverart'] = 1; else $optionsarray['enable_coverart'] = 0;
		if (isset($_POST['enable_artistimage']) && intval($_POST['enable_artistimage']) ) $optionsarray['enable_artistimage'] = 1; else $optionsarray['enable_artistimage'] = 0;
		if (isset($_POST['enable_info']) && intval($_POST['enable_info']) ) $optionsarray['enable_info'] = 1; else $optionsarray['enable_info'] = 0;
		if (isset($_POST['enable_tabs']) && intval($_POST['enable_tabs']) ) $optionsarray['enable_tabs'] = 1; else $optionsarray['enable_tabs'] = 0;
		if (isset($_POST['enable_coverart']) && intval($_POST['enable_coverart']) ) $optionsarray['enable_coverart'] = 1; else $optionsarray['enable_coverart'] = 0;
		if (isset($_POST['fancyness']) && intval($_POST['fancyness']) ) $optionsarray['fancyness'] = 1; else $optionsarray['fancyness'] = 0;
		if (isset($_POST['use_stylesheet']) && intval($_POST['use_stylesheet']) ) $optionsarray['use_stylesheet'] = 1; else $optionsarray['use_stylesheet'] = 0;
		if ($optionsarray['trackcount'] < 1) $optionsarray['trackcount'] = 1;
		if ($optionsarray['shoutcount'] < 1) $optionsarray['shoutcount'] = 1;
		if ($optionsarray['friendscount'] < 1) $optionsarray['friendscount'] = 1;
		if ($optionsarray['lovedcount'] < 1) $optionsarray['lovedcount'] = 1;
		if ($optionsarray['expiration'] < 1) $optionsarray['expiration'] = 10;
		update_option('lastfm_tabs_options', $optionsarray);
		clear_transient();
		_e('<div id="message" class="updated fade"><p>Your settings have been updated.</p></div>', 'lastfm_tabs');
	}

	if( (isset($_POST['clear_cache'])) && ($_POST['clear_cache']=="true") ){
		clear_transient();
	}
	if (!empty($text)) { echo '<div id="message" class="updated fade"><p>'.$text.'</p></div>'; } ?>

	<div class="wrap">
		<h2><?php _e('Last.fm options:', 'lastfm_tabs'); ?></h2>
		
		<form method="post">

			<p><?php _e('Title:', 'lastfm_tabs'); ?>
				<input type="text" name="widgettitle" value="<?php echo stripslashes(htmlspecialchars($optionsarray['widgettitle'])); ?>" size="30">
			</p>

			<p><?php _e('Last.fm username:', 'lastfm_tabs'); ?>
				<input type="text" name="username" value="<?php echo stripslashes(htmlspecialchars($optionsarray['username'])); ?>" size="30">
			</p>

			<p><?php _e('Cache expiration:', 'lastfm_tabs'); ?>
				<input type="text" name="expiration" value="<?php echo stripslashes(htmlspecialchars($optionsarray['expiration'])); ?>" size="4"> <?php _e('minutes', 'lastfm_tabs'); ?>
			</p>

<!--
			<p><?php _e('Debug mode:', 'lastfm_tabs'); ?>
				<input type="checkbox" name="debugmode" value="1" <?php checked($optionsarray['debugmode']); ?>>
			</p>
-->

			<p><?php _e('Fancy mouseover effect (requires stylesheet)?', 'lastfm_tabs'); ?>
				<input type="checkbox" name="fancyness" value="1" <?php checked($optionsarray['fancyness']); ?>>
			</p>

			<p><?php _e('Use stylesheet (For mouseover effect. Fixed image width)?', 'lastfm_tabs'); ?>
				<input type="checkbox" name="use_stylesheet" value="1" <?php checked($optionsarray['use_stylesheet']); ?>>
			</p>

			<p><?php _e('Enable tabbed display?', 'lastfm_tabs'); ?>
				<input type="checkbox" name="enable_tabs" value="1" <?php checked($optionsarray['enable_tabs']); ?>>
			</p>

			<h2><?php _e('Last.fm cover display options:', 'lastfm_tabs'); ?></h2>

			<p><?php _e('Enable cover art tab?', 'lastfm_tabs'); ?>
				<input type="checkbox" name="enable_coverart" value="1" <?php checked($optionsarray['enable_coverart']); ?>>
			</p>

			<p><?php _e('Address of default cover:', 'lastfm_tabs'); ?>
				<input type="text" name="nocoverurl" value="<?php echo stripslashes(htmlspecialchars($optionsarray['nocoverurl'])); ?>" size="60">
			</p>
			
			<img src="<?php echo stripslashes(htmlspecialchars($optionsarray['nocoverurl'])); ?>" alt="" title="No Cover"/>
			
			<p><?php _e('Show artist image when no album cover is found instead of default cover? (May increase loading time)', 'lastfm_tabs'); ?>
				<input type="checkbox" name="enable_artistimage" value="1" <?php checked($optionsarray['enable_artistimage']); ?>>
			</p>

			<p><?php _e('Number of covers to display:', 'lastfm_tabs'); ?>
				<input type="text" name="trackcount" value="<?php echo stripslashes(htmlspecialchars($optionsarray['trackcount'])); ?>" size="3">
			</p>

			<p><?php _e('Cover size:', 'lastfm_tabs'); ?>
				<select name="cover_size" size="1">
					<option value="0"<?php selected('0', $optionsarray['cover_size']); ?>><?php _e('small', 'lastfm_tabs'); ?></option>
					<option value="1"<?php selected('1', $optionsarray['cover_size']); ?>><?php _e('medium', 'lastfm_tabs'); ?></option>
					<option value="2"<?php selected('2', $optionsarray['cover_size']); ?>><?php _e('large', 'lastfm_tabs'); ?></option>
					<option value="3"<?php selected('3', $optionsarray['cover_size']); ?>><?php _e('extra large', 'lastfm_tabs'); ?></option>
				</select>
			</p>

			<h2><?php _e('Last.fm info options:', 'lastfm_tabs'); ?></h2>

			<p><?php _e('Enable user info tab?', 'lastfm_tabs'); ?>
				<input type="checkbox" name="enable_info" value="1" <?php checked($optionsarray['enable_info']); ?>>
			</p>

			<h2><?php _e('Last.fm friends options:', 'lastfm_tabs'); ?></h2>

			<p><?php _e('Enable friends tab?', 'lastfm_tabs'); ?>
				<input type="checkbox" name="enable_friends" value="1" <?php checked($optionsarray['enable_friends']); ?>>
			</p>

			<p><?php _e('Number of friends to display:', 'lastfm_tabs'); ?>
				<input type="text" name="friendscount" value="<?php echo stripslashes(htmlspecialchars($optionsarray['friendscount'])); ?>" size="3">
			</p>

			<p><?php _e('Friends avatar size:', 'lastfm_tabs'); ?>
				<select name="avatar_size" size="1">
					<option value="0"<?php selected('0', $optionsarray['avatar_size']); ?>><?php _e('small', 'lastfm_tabs'); ?></option>
					<option value="1"<?php selected('1', $optionsarray['avatar_size']); ?>><?php _e('medium', 'lastfm_tabs'); ?></option>
					<option value="2"<?php selected('2', $optionsarray['avatar_size']); ?>><?php _e('large', 'lastfm_tabs'); ?></option>
					<option value="3"<?php selected('3', $optionsarray['avatar_size']); ?>><?php _e('extra large', 'lastfm_tabs'); ?></option>
				</select>
			</p>

			<h2><?php _e('Last.fm loved tracks options:', 'lastfm_tabs'); ?></h2>

			<p><?php _e('Enable loved tracks tab?', 'lastfm_tabs'); ?>
				<input type="checkbox" name="enable_lovedtracks" value="1" <?php checked($optionsarray['enable_lovedtracks']); ?>>
			</p>

			<p><?php _e('Cover size:', 'lastfm_tabs'); ?>
				<select name="loved_size" size="1">
					<option value="0"<?php selected('0', $optionsarray['loved_size']); ?>><?php _e('small', 'lastfm_tabs'); ?></option>
					<option value="1"<?php selected('1', $optionsarray['loved_size']); ?>><?php _e('medium', 'lastfm_tabs'); ?></option>
					<option value="2"<?php selected('2', $optionsarray['loved_size']); ?>><?php _e('large', 'lastfm_tabs'); ?></option>
					<option value="3"<?php selected('3', $optionsarray['loved_size']); ?>><?php _e('extra large', 'lastfm_tabs'); ?></option>
				</select>
			</p>

			<p><?php _e('Number of loved tracks to display:', 'lastfm_tabs'); ?>
				<input type="text" name="lovedcount" value="<?php echo stripslashes(htmlspecialchars($optionsarray['lovedcount'])); ?>" size="3">
			</p>

			<h2><?php _e('Last.fm shouts options:', 'lastfm_tabs'); ?></h2>

			<p><?php _e('Enable shouts tab?', 'lastfm_tabs'); ?>
				<input type="checkbox" name="enable_shouts" value="1" <?php checked($optionsarray['enable_shouts']); ?>>
			</p>

			<p><?php _e('Number of shouts to display:', 'lastfm_tabs'); ?>
				<input type="text" name="shoutcount" value="<?php echo stripslashes(htmlspecialchars($optionsarray['shoutcount'])); ?>" size="3">
			</p>

			<p class="submit">
				<input type="submit" name="lastfm-submit" class="button" value="<?php _e('Update options', 'lastfm_tabs'); ?>" />
			</p>

			<hr />

		</form>
		<form action="" method="post">
			<p><?php _e('To delete the cache and manually refresh your last.fm-covers, push this button:', 'lastfm_tabs'); ?></p>
			<p class="submit">
				<input type="hidden" name="clear_cache" value="true" />
				<input type="submit" name="clearcache" class="button" value="<?php _e('Clear cache', 'lastfm_tabs'); ?>" />
			</p>
		</form>
	</div>
<?php }

//clear cache
function clear_transient(){
	delete_transient('lastfm_tabs_cache');
	echo '<div id="message" class="updated fade"><p>'.__('Cache cleared.','lastfm_tabs').'</p></div>';
}

//get artist image
function get_artist_image($artistname){
	$optionsarray = get_option('lastfm_tabs_options');
	$cover_size = $optionsarray['cover_size'];
	$nocoverurl = $optionsarray['nocoverurl'];
	$artistimage = new DOMDocument();
	if ($artistimage->load('http://ws.audioscrobbler.com/2.0/?method=artist.getinfo&artist='.$artistname.'&limit=1&api_key=21afc70179cc8d0aa11aae5a6253a535')) {
		$t_image = $artistimage->getElementsByTagName('image')->item($cover_size);
		if ( isset($t_image->nodeValue) && ($t_image->nodeValue) ) return $t_image->nodeValue; 
		else return $nocoverurl;
	}
	else {
		return $nocoverurl;
	}
}

//get friends
function get_lastfm_friends(){
	$optionsarray = get_option('lastfm_tabs_options');
	$friendscount = $optionsarray['friendscount'];
	$avatar_size = $optionsarray['avatar_size'];
	$username = $optionsarray['username'];
	$friends = new DOMDocument();
	if ($friends->load('http://ws.audioscrobbler.com/2.0/?method=user.getfriends&user='.$username.'&limit='.$friendscount.'&api_key=21afc70179cc8d0aa11aae5a6253a535')) {	
		//cover info header
		$friends_output = '<li class="records_tab" id="lastfmfriends">';
		$i=1;
		foreach ($friends->getElementsByTagName('user') as $node) {
			$friendsavatar = $node->getElementsByTagName('image')->item($avatar_size)->nodeValue;
			$friendsurl = $node->getElementsByTagName('url')->item(0)->nodeValue;
			$friendsname = $node->getElementsByTagName('name')->item(0)->nodeValue;
			$friends_output .= '<div class="lastfm_record"><a href="'.$friendsurl.'" target="_blank"><img src="'.$friendsavatar.'" alt="'.$friendsname.'" title="'.$friendsname.'"/></a>'."\n".'<div class="boxcaptionsmall"><p>'.$friendsname.'</p></div></div>'."\n";
			if($i++ >= $friendscount) break;
		}
	}
	$friends_output .= '<br class="clear" /></li><!--recordstab friends-->'."\n";
	return $friends_output;
}

//get loved tracks
function get_lastfm_loved_tracks(){
	$optionsarray = get_option('lastfm_tabs_options');
	$lovedcount = $optionsarray['lovedcount'];
	$loved_size = $optionsarray['loved_size'];
	$nocoverurl = $optionsarray['nocoverurl'];
	$username = $optionsarray['username'];
	$lovedtracks = new DOMDocument();
	if ($lovedtracks->load('http://ws.audioscrobbler.com/2.0/?method=user.getlovedtracks&user='.$username.'&limit='.$lovedcount.'&api_key=21afc70179cc8d0aa11aae5a6253a535')) {	
		$loved_output = '<li class="records_tab" id="lastfmloved">';
		$i=1;
		foreach ($lovedtracks->getElementsByTagName('track') as $node) {
			$lovedurl = $node->getElementsByTagName('url')->item(0)->nodeValue;
			$t_artist = $node->getElementsByTagName('artist')->item(0);
			$artistname = $t_artist->getElementsByTagName('name')->item(0)->nodeValue;
			$artisturl = $t_artist->getElementsByTagName('url')->item(0)->nodeValue;
			$lovedtrack = $node->getElementsByTagName('name')->item(0)->nodeValue;
			$t_lovedcover = $node->getElementsByTagName('image')->item($loved_size);
			//set cover for not found cover art
			if ( isset($t_lovedcover->nodeValue) && ($t_lovedcover->nodeValue) ) $lovedcover = $t_lovedcover->nodeValue; 
			elseif ( isset($optionsarray['enable_artistimage']) && intval($optionsarray['enable_artistimage']) ) $lovedcover = get_artist_image($artistname);
			else $lovedcover = $nocoverurl;
			$loved_output .= '<div class="lastfm_record"><a href="http://'.$lovedurl.'" target="_blank"><img src="'.$lovedcover.'" alt="'.$lovedtrack.'" /></a><div class="boxcaptionsmall"><p>'.$artistname.'</p><p>'.$lovedtrack.'</p></div></div>'."\n";

			if($i++ >= $lovedcount) break;
		}
	}
	$loved_output .= '<br class="clear" /></li>'."\n";
	return $loved_output;
}

//get shouts
function get_lastfm_shouts(){
	$optionsarray = get_option('lastfm_tabs_options');
	$shoutcount = $optionsarray['shoutcount'];
	$username = $optionsarray['username'];
	$shouts = new DOMDocument();
	if ($shouts->load('http://ws.audioscrobbler.com/2.0/?method=user.getshouts&user='.$username.'&api_key=21afc70179cc8d0aa11aae5a6253a535')) {	
		$shouts_output = '<li class="records_tab" id="lastfmshouts">';
		$i=1;
		foreach ($shouts->getElementsByTagName('shout') as $node) {
			$shout = $node->getElementsByTagName('body')->item(0)->nodeValue;
			$author = $node->getElementsByTagName('author')->item(0)->nodeValue;
			$date = $node->getElementsByTagName('date')->item(0)->nodeValue;
			$shouts_output .= '<div class="lastfm_record"><p>'.$shout.'</p><p>'.$author.'</p><p>'.$date.'</p></div>'."\n";
			if($i++ >= $shoutcount) break;
		}
	}
	$shouts_output .= '<br class="clear" /></li>'."\n";
	return $shouts_output;
}

//get user info
function get_lastfm_userinfo(){
	$optionsarray = get_option('lastfm_tabs_options');
	$username = $optionsarray['username'];
	$userinfo = new DOMDocument();
	if ($userinfo->load('http://ws.audioscrobbler.com/2.0/?method=user.getinfo&user='.$username.'&api_key=21afc70179cc8d0aa11aae5a6253a535')) {
		$id = $userinfo->getElementsByTagName('id')->item(0)->nodeValue;
		$name = $userinfo->getElementsByTagName('name')->item(0)->nodeValue; 
		$real = $userinfo->getElementsByTagName('realname')->item(0)->nodeValue;
		$user_url = $userinfo->getElementsByTagName('url')->item(0)->nodeValue;
		$userimage = $userinfo->getElementsByTagName('image')->item(0)->nodeValue;
		$country = $userinfo->getElementsByTagName('country')->item(0)->nodeValue;
		$age = $userinfo->getElementsByTagName('age')->item(0)->nodeValue;
		$gender = $userinfo->getElementsByTagName('gender')->item(0)->nodeValue;
		$playcount = $userinfo->getElementsByTagName('playcount')->item(0)->nodeValue;
		$registered = $userinfo->getElementsByTagName('registered')->item(0)->nodeValue;
	}
	$info_output = '<li class="records_tab" id="lastfminfo">'."\n".'<p><img src="'.$userimage.'" alt="'.$name.'"/></p><p>'. __('ID: ','lastfm_tabs').$id.'</p><p>'. __('Nick: ','lastfm_tabs').$name.'</p><p>'. __('Name: ','lastfm_tabs').$real.'</p><p>'. __('Country: ','lastfm_tabs').$country.'</p><p>'. __('Age: ','lastfm_tabs').$age.'</p><p>'. __('Gender: ','lastfm_tabs').$gender.'</p><p>'. __('Playcount: ','lastfm_tabs').$playcount.'</p><p><a href="'.$user_url.'">'. __('Profilepage','lastfm_tabs').'</a></p><p>'. __('Registered: ','lastfm_tabs').$registered.'</p>'."\n".'<br class="clear" /></li>'."\n";
	return $info_output;
}

// get cover art		
function get_lastfm_coverart(){
	$optionsarray = get_option('lastfm_tabs_options');
	$cover_size = $optionsarray['cover_size'];
	$trackcount = $optionsarray['trackcount'];
	$nocoverurl = $optionsarray['nocoverurl'];
	$username = $optionsarray['username'];
	$coverinfo = new DOMDocument();
	$cover_output = '<li class="records_tab" id="lastfmcovers">';
	if ($coverinfo->load('http://ws.audioscrobbler.com/2.0/?method=user.getrecenttracks&user='.$username.'&limit='.$trackcount.'&api_key=21afc70179cc8d0aa11aae5a6253a535')) {
		$i = 1;
		foreach ($coverinfo->getElementsByTagName('track') as $node) {
			$song = $node->getElementsByTagName('name')->item(0)->nodeValue;
			$artist = $node->getElementsByTagName('artist')->item(0)->nodeValue;
			$url = $node->getElementsByTagName('url')->item(0)->nodeValue;
			$t_cover = $node->getElementsByTagName('image')->item($cover_size);
			//set cover for not found cover art
			if ( isset($t_cover->nodeValue) && ($t_cover->nodeValue) ) $cover = $t_cover->nodeValue; 
			elseif ( isset($optionsarray['enable_artistimage']) && intval($optionsarray['enable_artistimage']) ) $cover = get_artist_image($artist);
			else $cover = $nocoverurl;
			
			$cover_output .= '<div class="lastfm_record"><a href="'.$url.'" target="_blank"><img src="'.$cover.'" alt="'.$song.'" title="'.$artist.' - '.$song.'"/></a>'."\n".'<div class="boxcaptionsmall"><p>'.$song.'</p><p>'.$artist.'</p></div></div>'."\n";
			if($i++ >= $trackcount) break;
		}
	}
	$cover_output.= '<br class="clear" /></li>'."\n";
	return $cover_output;
}

//widget
function lastfm_tabs_main($args){
	extract($args);
	$optionsarray = get_option('lastfm_tabs_options');
	$widgettitle = $optionsarray['widgettitle'];
	
	//build navigation and tabs if enabled
	if ( isset($optionsarray['enable_friends']) && intval($optionsarray['enable_friends']) ){
		$lastfmfriends = get_lastfm_friends();
		$friends_nav = '<li><a href="#lastfmfriends">'. __('Friends','lastfm_tabs').'</a></li>';
	}	
	else {
		$lastfmfriends= '';
		$friends_nav = '';
	}
	if ( isset($optionsarray['enable_info']) && intval($optionsarray['enable_info']) ) {
		$lastfmuserinfo = get_lastfm_userinfo();
		$info_nav = '<li><a href="#lastfminfo">'. __('Info','lastfm_tabs').'</a></li>';
	}
	else {
		$lastfmuserinfo = '';
		$info_nav = '';
	}
	if ( isset($optionsarray['enable_lovedtracks']) && intval($optionsarray['enable_lovedtracks']) ) {
		$lastfmloved = get_lastfm_loved_tracks();
		$loved_nav = '<li><a href="#lastfmloved">'. __('Loved tracks','lastfm_tabs').'</a></li>';
	}
	else {
		$lastfmloved = '';
		$loved_nav = '';
	}
	if ( isset($optionsarray['enable_shouts']) && intval($optionsarray['enable_shouts']) ) {
		$lastfmshouts = get_lastfm_shouts(); 
		$shouts_nav = '<li><a href="#lastfmshouts">'. __('Shouts','lastfm_tabs').'</a></li>';
	}	
	else {
		$lastfmshouts = '';
		$shouts_nav = '';
	}
	if ( isset($optionsarray['enable_coverart']) && intval($optionsarray['enable_coverart']) ) {
		$lastfmcoverart = get_lastfm_coverart(); 
		$cover_nav = '<li><a href="#lastfmcovers">'. __('Title','lastfm_tabs').'</a></li>';
	}	
	else {
		$lastfmcoverart='';
		$cover_nav = '';
	}
	
	//tabbed navigation		
	$tab_nav = '<ul class="idTabs molastfm clearfix">'.$cover_nav.$friends_nav.$shouts_nav.$info_nav.$loved_nav.'</ul>'."\n";
		
	//widget start
	$widget_output = $before_widget . $before_title . $widgettitle . $after_title. "\n";
	$widget_output .= '<div id="lastfmrecords">'.$tab_nav.'<ul id="lastfm_inside">';

//	$widget_output = $before_widget . $before_title . $widgettitle . '</h3>'."\n";
//	$widget_output .= $tab_nav. '<div class="inside lastfminside">';

	//echo cache info in debug mode
	if ( isset($optionsarray['debugmode']) && intval($optionsarray['debugmode']) ) {
		$timestamp = time();
		$extime = date("H:i:s",$timestamp);
		print 'Cacherefresh done at '.$extime;
	}
	
	$widget_output .= $lastfmcoverart.$lastfmuserinfo.$lastfmfriends.$lastfmloved.$lastfmshouts;
	$widget_output .= '</ul><!--inside--></div><!--id lastfmrecords-->' . $after_widget . "\n";
	//$widget_output .= '</div><!--inside-->' . "\n";
	return $widget_output;	
}

//output and transient
function show_lasftm_widget_output($args) {
	$optionsarray = get_option('lastfm_tabs_options');
	$expiration = $optionsarray['expiration']*60;
	$transient = 'lastfm_tabs_cache';
	$output_data = get_transient($transient);
	if (false === $output_data) {
		if ( isset($optionsarray['debugmode']) && intval($optionsarray['debugmode']) ) echo ' Data not in cache.'."\n";
		$output_data = lastfm_tabs_main($args);
		set_transient($transient, $output_data,$expiration);
	}
	elseif ( isset($optionsarray['debugmode']) && intval($optionsarray['debugmode']) ) echo 'Data in cache.';
	echo $output_data;
}


//init
function init_lastfm_tabs() {
	//load textdomain
	$plugin_dir = basename(dirname(__FILE__));
	load_plugin_textdomain( 'lastfm_tabs', 'wp-content/plugins/' . $plugin_dir, $plugin_dir );

	register_sidebar_widget("Last.fm Tabs", "show_lasftm_widget_output");

	$optionsarray = array(
		'username' => '',
		'cover_size' => '2',
		'widgettitle' => 'Last.fm',
		'trackcount' => '4',
		'lovedcount' => '4',
		'shoutcount' => '4',
		'loved_size' => '2',
		'avatar_size' => '2',
		'friendscount' => '4',
		'expiration' => '15',
		'debugmode' => 0,
		'enable_info' => 0,
		'enable_shouts' => 0,
		'enable_coverart' => 1,
		'enable_friends' => 1,
		'enable_lovedtracks' => 1,
		'enable_tabs' => 1,
		'enable_artistimage' => 0,
		'fancyness' => 1,
		'use_stylesheet' => 1,
		'nocoverurl' => 'http://cdn.last.fm/depth/catalogue/noimage/cover_85px.gif'
	);

	add_option('lastfm_tabs_options', $optionsarray, 'Last.fm options');
	add_action('wp_print_styles', 'lastfm_tabs_stylesheet');
	lastfm_tabs_tabs();
	lastfm_tabs_hover();
}

//enable tabs?
function lastfm_tabs_hover() {
	$optionsarray = get_option('lastfm_tabs_options');
	if ( isset($optionsarray['fancyness']) && intval($optionsarray['fancyness']) )
		wp_enqueue_script('fancy_hover', WP_PLUGIN_URL . '/lastfm-tabs/fancy_hover.js','jquery','1',false);
}


//enable hovers?
function lastfm_tabs_tabs() {
	$optionsarray = get_option('lastfm_tabs_options');
	if ( isset($optionsarray['enable_tabs']) && intval($optionsarray['enable_tabs']) )
		wp_enqueue_script('idtabs', WP_PLUGIN_URL . '/lastfm-tabs/idtab.js','jquery','1',false);
}

//optional stylesheet
function lastfm_tabs_stylesheet() {
	$optionsarray = get_option('lastfm_tabs_options');

	if ( isset($optionsarray['use_stylesheet']) && !intval($optionsarray['use_stylesheet']) )
		return;
	if (@file_exists(STYLESHEETPATH.'/lastfm.css'))	$css_file = get_stylesheet_directory_uri() . '/lastfm.css';
	elseif (@file_exists(TEMPLATEPATH.'/lastfm.css')) $css_file = get_template_directory_uri() . '/lastfm.css';	
	else $css_file = plugins_url('lastfm_tabs.css', __FILE__);

	wp_enqueue_style('lastfm_tabs', $css_file, false, '1.0', 'all');
}

add_action("plugins_loaded", "init_lastfm_tabs");

?>